"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readFile = exports.saveFile = void 0;
const selectors_1 = require("../selectors");
function saveFile(storyName, current) {
    const anchor = document.getElementById(selectors_1.hiddenFileAnchorId);
    if (anchor) {
        anchor.setAttribute('href', 'data:text/json,' + encodeURIComponent(JSON.stringify(current, null, 2)));
        anchor.setAttribute('download', `${storyName}.json`);
        anchor.click();
    }
}
exports.saveFile = saveFile;
function readFile(e, callback) {
    const reader = new FileReader();
    const { files } = e.currentTarget;
    if (files && files.length) {
        reader.readAsText(files[0]);
        reader.onload = ({ target }) => {
            if (target) {
                const context = JSON.parse(target.result);
                const [storyName] = files[0].name.split('.json');
                callback(context, storyName);
            }
        };
    }
}
exports.readFile = readFile;
