"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const theming_1 = require("@storybook/theming");
const react_1 = __importStar(require("react"));
const selectors_1 = require("../selectors");
const get_groups_1 = require("../tasks/get-groups");
const machine_1 = __importDefault(require("./machine"));
const service_context_1 = __importDefault(require("./service-context"));
const task_group_1 = __importDefault(require("./task-group"));
const top_bar_1 = __importDefault(require("./top-bar"));
const use_panel_machine_1 = __importDefault(require("./use-panel-machine"));
const Container = theming_1.styled.div `
  --grid: 10px;
  --halfGrid: calc(var(--grid) / 2);

  font-size: 16px;
  line-height: 1.5;
`;
const GroupContainer = theming_1.styled.div `
  display: grid;
  grid-template-columns: repeat(auto-fit, minmax(350px, 1fr));
  min-height: 100%;
  padding: 0 var(--halfGrid);
`;
function findResult(group, context) {
    if (!context || !context.results) {
        return null;
    }
    const result = context.results.find((item) => item.groupId === group.groupId);
    return result || null;
}
function Panel({ channel, interactions, allowedGroups, }) {
    const { state, service } = use_panel_machine_1.default(machine_1.default, channel);
    const groups = react_1.useMemo(() => get_groups_1.getGroups({ allowedGroups, interactions }), [
        interactions,
        allowedGroups,
    ]);
    return (react_1.default.createElement(service_context_1.default.Provider, { value: service },
        react_1.default.createElement(Container, { id: selectors_1.panelId },
            react_1.default.createElement(top_bar_1.default, null),
            react_1.default.createElement(GroupContainer, null, groups.map((group) => {
                if (state.context.current.results == null) {
                    return null;
                }
                return (react_1.default.createElement(task_group_1.default, { key: group.groupId, group: group, result: findResult(group, state.context.current), pinned: findResult(group, state.context.pinned) }));
            })))));
}
exports.default = Panel;
