"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const theming_1 = require("@storybook/theming");
const react_1 = __importDefault(require("react"));
const get_interaction_group_1 = require("../tasks/get-interaction-group");
const components_1 = require("@storybook/components");
const task_result_1 = __importDefault(require("./task-result"));
const Title = theming_1.styled.h3 `
  font-weight: bold;
  margin-bottom: var(--grid);
`;
const Container = theming_1.styled.div `
  padding: var(--halfGrid);
`;
function EmptyGroupMessage({ group }) {
    if (group.groupId === get_interaction_group_1.interactionGroupId && !group.tasks.length) {
        return (react_1.default.createElement("small", null,
            "No",
            ' ',
            react_1.default.createElement(components_1.Link, { href: "https://github.com/atlassian-labs/storybook-addon-performance#usage-interactions", target: "_blank", rel: "noopener" }, "interactions"),
            ' ',
            "defined."));
    }
    return null;
}
exports.default = react_1.default.memo(function TaskGroup({ group, result, pinned }) {
    if (!result) {
        return null;
    }
    return (react_1.default.createElement(Container, null,
        react_1.default.createElement(Title, null, group.name),
        react_1.default.createElement(EmptyGroupMessage, { group: group }),
        group.tasks.map((task) => {
            return (react_1.default.createElement(task_result_1.default, { key: task.name, task: task, result: result.map[task.name] || null, pinned: (pinned === null || pinned === void 0 ? void 0 : pinned.map[task.name]) || null }));
        })));
});
