"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const expanding_result_1 = require("./expanding-result");
const Parts = __importStar(require("./parts"));
function ErrorSection({ result }) {
    const message = result.message ? (react_1.default.createElement(Parts.Content, null,
        "Message: ",
        result.message)) : null;
    if (result.reason === 'unhandled') {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(Parts.Heading, null, "Error \u274C"),
            react_1.default.createElement(Parts.Content, null, "An unhandled error has occurred while running this task"),
            message));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Parts.Heading, null, "Unsupported \u26A0\uFE0F"),
        react_1.default.createElement(Parts.Content, null, "This task is not supported in the current running environment"),
        message));
}
function Expanded({ task, result }) {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(ErrorSection, { result: result }),
        react_1.default.createElement(Parts.Heading, null, "Description"),
        react_1.default.createElement(Parts.Content, null, task.description)));
}
function ErrorResultView({ task, result }) {
    const resultNode = result.reason === 'unsupported' ? (react_1.default.createElement(Parts.ValueLozenge, { type: "warning" }, "Unsupported")) : (react_1.default.createElement(Parts.ValueLozenge, { type: "negative" }, "Error"));
    return (react_1.default.createElement(expanding_result_1.ExpandingResult, { name: task.name, result: resultNode, getExpanded: ({ isExpanded }) => isExpanded ? react_1.default.createElement(Expanded, { task: task, result: result }) : null }));
}
exports.default = ErrorResultView;
