"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExpandingResult = void 0;
const react_1 = __importStar(require("react"));
const theming_1 = require("@storybook/theming");
const Expand = __importStar(require("./parts"));
const components_1 = require("@storybook/components");
const react_2 = require("@xstate/react");
const use_required_context_1 = __importDefault(require("../../use-required-context"));
const service_context_1 = __importDefault(require("../service-context"));
const pluralise_1 = require("../../util/pluralise");
const next_events_include_1 = __importDefault(require("../next-events-include"));
const Container = theming_1.styled.div `
  --result-border-radius: 4px;
  margin-bottom: var(--grid);
  border: 1px solid lightgray;
  border-radius: var(--result-border-radius);
`;
const HeaderButton = theming_1.styled.button `
  /* reset */
  margin: 0;
  padding: 0;
  border: none;

  width: 100%;
  height: calc(var(--grid) * 4);
  text-align: left;
  font-size: 16px;
  font-weight: bold;

  border-radius: var(--result-border-radius);
  background-color: ${(props) => props.theme.background.content};
  color: ${(props) => props.theme.color.defaultText};

  display: flex;
  align-items: center;
  padding: 0 var(--grid);

  > * {
    margin-left: var(--grid);
    flex-shrink: 0;
  }
`;
const Name = theming_1.styled.h4 `
  /* the name will push the result over, it can also collapse when there is no room */
  flex-grow: 1;
  flex-shrink: 1;
  font-weight: bold;

  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
`;
const IconContainer = theming_1.styled.span `
  margin-left: 0;
  width: var(--grid);
  height: var(--grid);
`;
function ExpandIcon({ isExpanded }) {
    return (react_1.default.createElement(IconContainer, null,
        react_1.default.createElement(components_1.Icons, { icon: isExpanded ? 'arrowdown' : 'arrowright' })));
}
function ExpandingResult({ name, result, getExpanded }) {
    const [isExpanded, setIsExpanded] = react_1.useState(false);
    const toggle = react_1.useCallback(() => setIsExpanded((value) => !value), [setIsExpanded]);
    const service = use_required_context_1.default(service_context_1.default);
    const [state, send] = react_2.useService(service);
    const expanded = getExpanded({ isExpanded });
    const { copies, samples } = state.context.current;
    return (react_1.default.createElement(Container, null,
        react_1.default.createElement(HeaderButton, { onClick: toggle, isExpanded: isExpanded, "aria-expanded": isExpanded },
            react_1.default.createElement(ExpandIcon, { isExpanded: isExpanded }),
            react_1.default.createElement(Name, null, name),
            result),
        isExpanded ? (react_1.default.createElement(Expand.Section, null,
            react_1.default.createElement(components_1.Button, { secondary: true, small: true, disabled: !next_events_include_1.default('START_ONE', state.nextEvents), onClick: () => send({ type: 'START_ONE', taskName: name }) },
                "Run task",
                ' ',
                react_1.default.createElement("small", null,
                    "(",
                    copies,
                    " ",
                    pluralise_1.pluraliseCopies(copies),
                    ", ",
                    samples,
                    " ",
                    pluralise_1.pluraliseSamples(samples),
                    ")")),
            expanded)) : null));
}
exports.ExpandingResult = ExpandingResult;
