"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValueCell = exports.TitleCell = exports.Table = exports.ValueLozenge = exports.ResultScale = exports.ResultValue = exports.Note = exports.Content = exports.Heading = exports.Section = void 0;
const theming_1 = require("@storybook/theming");
exports.Section = theming_1.styled.div `
  background-color: ${(props) => props.theme.background.content};
  padding: var(--grid);
  padding-top: 0;

  > * {
    margin-top: var(--grid);
  }

  &:last-of-type {
    border-bottom-left-radius: var(--result-border-radius);
    border-bottom-right-radius: var(--result-border-radius);
  }
`;
exports.Heading = theming_1.styled.h4 `
  font-weight: bold;
`;
exports.Content = theming_1.styled.div ``;
exports.Note = theming_1.styled.div `
  padding: calc(var(--grid) / 2);
  background-color: ${(props) => props.theme.background.hoverable};
  border-radius: var(--result-border-radius);
  font-size: small;

  &::before {
    margin-right: 1ch;
    content: 'ℹ️';
  }
`;
exports.ResultValue = theming_1.styled.code `
  /* font-family: 'Courier'; */
`;
exports.ResultScale = theming_1.styled.code `
  /* slightly smaller margin that other elements */
  margin-left: var(--halfGrid);
`;
exports.ValueLozenge = theming_1.styled.code `
  ${({ hasWarningIcon = true }) => !hasWarningIcon &&
    `&:before {
      content: '⚠️';
      margin-right: 1ch;
    }`};
  padding: calc(var(--grid) / 2) var(--grid);
  border-radius: var(--result-border-radius);
  color: ${(props) => props.theme.color.light};
  font-weight: bold;
  font-size: small;
  background-color: ${({ type, theme }) => {
    switch (type) {
        case 'positive':
            return theme.color.positive;
        case 'negative':
            return theme.color.negative;
        case 'faint':
            return theme.color.medium;
        case 'warning':
            return theme.color.warning;
        case 'info':
            return theme.color.seafoam;
        default:
            return theme.color.purple;
    }
}};
`;
exports.Table = theming_1.styled.table `
  width: 100%;
`;
exports.TitleCell = theming_1.styled.td ``;
exports.ValueCell = theming_1.styled.td `
  text-align: right;
`;
