"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const to_fixed_1 = __importDefault(require("../../util/to-fixed"));
const expanding_result_1 = require("./expanding-result");
const Parts = __importStar(require("./parts"));
const get_change_1 = __importDefault(require("../../util/get-change"));
function getDiff({ result, pinned }) {
    if (!pinned) {
        return 0;
    }
    return get_change_1.default({
        baseline: pinned.averageMs,
        value: result.averageMs,
    });
}
function DiffToPinned({ result, pinned }) {
    if (pinned == null) {
        return null;
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Parts.Heading, null, "Compared with pinned"),
        react_1.default.createElement(Parts.Content, null,
            react_1.default.createElement(Parts.Table, null,
                react_1.default.createElement("tbody", null,
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement(Parts.TitleCell, null, "Pinned value"),
                        react_1.default.createElement(Parts.ValueCell, null,
                            react_1.default.createElement(Parts.ValueLozenge, { type: "raw" },
                                to_fixed_1.default(pinned.averageMs, 1),
                                "ms"))),
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement(Parts.TitleCell, null, "Current value"),
                        react_1.default.createElement(Parts.ValueCell, null,
                            react_1.default.createElement(Parts.ValueLozenge, { type: "raw" },
                                to_fixed_1.default(result.averageMs, 1),
                                "ms"))),
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement(Parts.TitleCell, null, "Difference"),
                        react_1.default.createElement(Parts.ValueCell, null,
                            react_1.default.createElement(DiffLozenge, { diff: getDiff({ result, pinned }) }))))))));
}
function Variance({ result }) {
    if (result.samples === 1) {
        return null;
    }
    const wasStable = result.variance.standardDeviation < 1;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(Parts.Heading, null, "Variance"),
        react_1.default.createElement(Parts.Note, null, "When doing multiple runs there can be differences between the runs. The lower the variance, the higher confidence you can have"),
        react_1.default.createElement(Parts.Table, null,
            react_1.default.createElement("tbody", null,
                react_1.default.createElement("tr", null,
                    react_1.default.createElement(Parts.TitleCell, null, "Samples"),
                    react_1.default.createElement(Parts.ValueCell, null,
                        react_1.default.createElement(Parts.ValueLozenge, { type: "info" }, result.samples))),
                react_1.default.createElement("tr", null,
                    react_1.default.createElement(Parts.TitleCell, null, "Standard deviation"),
                    react_1.default.createElement(Parts.ValueCell, null,
                        react_1.default.createElement(Parts.ValueLozenge, { hasWarningIcon: wasStable, type: wasStable ? 'positive' : 'negative' }, to_fixed_1.default(result.variance.standardDeviation)))),
                react_1.default.createElement("tr", null,
                    react_1.default.createElement(Parts.TitleCell, null, "Lowest"),
                    react_1.default.createElement(Parts.ValueCell, null,
                        react_1.default.createElement(Parts.ValueLozenge, { type: "raw" },
                            "-",
                            to_fixed_1.default(result.variance.lowerPercentage),
                            "%"))),
                react_1.default.createElement("tr", null,
                    react_1.default.createElement(Parts.TitleCell, null, "Highest"),
                    react_1.default.createElement(Parts.ValueCell, null,
                        react_1.default.createElement(Parts.ValueLozenge, { type: "raw" },
                            "+",
                            to_fixed_1.default(result.variance.upperPercentage),
                            "%")))))));
}
function Expanded({ task, result, pinned, }) {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(DiffToPinned, { result: result, pinned: pinned }),
        react_1.default.createElement(Variance, { result: result }),
        react_1.default.createElement(Parts.Heading, null, "Description"),
        react_1.default.createElement(Parts.Content, null, task.description)));
}
function DiffLozenge({ diff }) {
    const type = (() => {
        const threshold = 5;
        if (diff > threshold) {
            return 'negative';
        }
        if (diff < -threshold) {
            return 'positive';
        }
        return 'faint';
    })();
    const sign = diff >= 0 ? '+' : '-';
    return (react_1.default.createElement(Parts.ValueLozenge, { type: type },
        sign,
        to_fixed_1.default(Math.abs(diff), 1),
        "%"));
}
function TimedResultView({ task, pinned, result }) {
    const diff = getDiff({ result, pinned });
    const resultNode = (react_1.default.createElement(react_1.default.Fragment, null,
        diff ? react_1.default.createElement(DiffLozenge, { diff: diff }) : null,
        react_1.default.createElement(Parts.ResultValue, null, to_fixed_1.default(result.averageMs)),
        ' ',
        react_1.default.createElement(Parts.ResultScale, null, "ms")));
    return (react_1.default.createElement(expanding_result_1.ExpandingResult, { name: task.name, result: resultNode, getExpanded: ({ isExpanded }) => isExpanded ? react_1.default.createElement(Expanded, { task: task, result: result, pinned: pinned }) : null }));
}
exports.default = TimedResultView;
