"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const components_1 = require("@storybook/components");
const theming_1 = require("@storybook/theming");
const react_1 = __importDefault(require("react"));
const use_required_context_1 = __importDefault(require("../use-required-context"));
const service_context_1 = __importDefault(require("./service-context"));
const react_2 = require("@xstate/react");
const pluralise_1 = require("../util/pluralise");
const next_events_include_1 = __importDefault(require("./next-events-include"));
const selectors = __importStar(require("../selectors"));
const file_system_1 = require("./file-system");
const TABLET_BREAKPOINT = 768;
const Container = theming_1.styled.div `
  display: flex;
  align-items: center;
  flex-wrap: wrap;
`;
const Message = theming_1.styled.small `
  text-overflow: ellipsis;
  overflow: hidden;
  white-space: nowrap;
  flex-shrink: 1;
  flex-grow: 1;
`;
const Segment = theming_1.styled.div `
  display: flex;
  align-items: center;

  > * {
    margin: var(--halfGrid) !important;
    flex-shrink: 0;
  }
`;
const HiddenAnchor = theming_1.styled.a `
  display: none;
`;
const FileButtons = theming_1.styled.div `
  flex: 1;
  display: flex;
  justify-content: flex-end;

  > * {
    margin: var(--halfGrid) !important;
    flex-shrink: 0;
  }
`;
const MetaSettings = theming_1.styled.div `
  flex: 1;
  display: flex;
  flex-wrap: nowrap;
  flex-direction: row;
`;
const ResponsiveIcon = theming_1.styled(components_1.Icons) `
  @media screen and (max-width: ${TABLET_BREAKPOINT}px) {
    margin-right: 0px !important;
  }
`;
const ResponsiveText = theming_1.styled.span `
  @media screen and (max-width: ${TABLET_BREAKPOINT}px) {
    display: none;
  }
`;
const CollapseSegment = theming_1.styled.div `
  margin: var(--halfGrid);
  align-items: center;
  display: grid;
  grid-template-columns: min-content minmax(100px, auto);
  gap: var(--halfGrid);
`;
function Topbar() {
    const service = use_required_context_1.default(service_context_1.default);
    const [state, send] = react_2.useService(service);
    const current = state.context.current;
    const pinned = state.context.pinned;
    const sizes = state.context.sizes;
    const enabled = {
        start: next_events_include_1.default('START_ALL', state.nextEvents),
        change: next_events_include_1.default('SET_VALUES', state.nextEvents) && pinned == null,
        pin: next_events_include_1.default('PIN', state.nextEvents) && current.results != null,
        unpin: next_events_include_1.default('UNPIN', state.nextEvents) && current.results != null,
    };
    const icons = {
        pin: pinned ? 'lock' : 'unlock',
        save: 'download',
        load: 'upload',
    };
    return (react_1.default.createElement(Container, null,
        react_1.default.createElement(Segment, null,
            react_1.default.createElement(components_1.Button, { css: {
                    textTransform: 'uppercase',
                }, primary: true, small: true, onClick: () => send({ type: 'START_ALL' }), disabled: !enabled.start, id: selectors.startAllButtonId }, "Start all"),
            react_1.default.createElement(components_1.Form.Select, { id: selectors.copySelectId, disabled: !enabled.change, value: current.copies, onChange: (event) => {
                    const values = {
                        samples: current.samples,
                        copies: Number(event.target.value),
                    };
                    send('SET_VALUES', values);
                } }, sizes.map((size) => (react_1.default.createElement("option", { key: size, value: size },
                size,
                " ",
                pluralise_1.pluraliseCopies(size))))),
            react_1.default.createElement(components_1.Form.Select, { id: selectors.sampleSelectId, disabled: !enabled.change, value: current.samples, onChange: (event) => {
                    const values = {
                        copies: current.copies,
                        samples: Number(event.target.value),
                    };
                    send('SET_VALUES', values);
                } }, sizes.map((size) => (react_1.default.createElement("option", { key: size, value: size },
                size,
                " ",
                pluralise_1.pluraliseSamples(size)))))),
        react_1.default.createElement(MetaSettings, null,
            react_1.default.createElement(CollapseSegment, null,
                react_1.default.createElement(components_1.Button, { id: selectors.pinButtonId, secondary: true, outline: !pinned, small: true, disabled: pinned ? !enabled.unpin : !enabled.pin, onClick: () => send({ type: pinned ? 'UNPIN' : 'PIN' }) },
                    react_1.default.createElement(ResponsiveIcon, { icon: icons.pin, "aria-label": icons.pin }),
                    react_1.default.createElement(ResponsiveText, null, pinned ? 'Unpin baseline' : 'Pin as baseline')),
                react_1.default.createElement(Message, null, state.context.message)),
            react_1.default.createElement(FileButtons, null,
                react_1.default.createElement(components_1.Button, { id: selectors.saveButtonId, secondary: true, small: true, outline: true, disabled: current.results == null, onClick: () => send({ type: 'SAVE' }) },
                    react_1.default.createElement(ResponsiveIcon, { icon: icons.save, "aria-label": icons.save }),
                    react_1.default.createElement(ResponsiveText, null, "Save result")),
                react_1.default.createElement(components_1.Button, { secondary: true, small: true, outline: true, onClick: () => {
                        var _a;
                        (_a = document.getElementById(selectors.loadButtonId)) === null || _a === void 0 ? void 0 : _a.click();
                    } },
                    react_1.default.createElement(ResponsiveIcon, { icon: icons.load, "aria-label": icons.load }),
                    react_1.default.createElement(ResponsiveText, null, "Load result")),
                react_1.default.createElement(components_1.Form.Input, { style: { display: 'none' }, id: selectors.loadButtonId, type: "file", accept: ".json", onChange: (e) => {
                        file_system_1.readFile(e, (results, storyName) => send('LOAD_FROM_FILE', { pinned: results, storyName }));
                    } })),
            react_1.default.createElement(HiddenAnchor, { id: selectors.hiddenFileAnchorId }))));
}
exports.default = Topbar;
