"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const custom_errors_1 = require("./custom-errors");
function getErrorResult({ task, error }) {
    if (error instanceof custom_errors_1.UnsupportedError) {
        return {
            type: 'error',
            taskName: task.name,
            reason: 'unsupported',
            message: error.message,
        };
    }
    return {
        type: 'error',
        taskName: task.name,
        reason: 'unhandled',
        message: null,
    };
}
exports.default = getErrorResult;
