"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runOneStatic = exports.runOneTimed = exports.runAll = void 0;
const to_safe_element_1 = __importDefault(require("./to-safe-element"));
const run_group_1 = __importDefault(require("./run-group"));
const run_static_task_1 = require("./run-static-task");
const run_timed_task_1 = require("./run-timed-task");
async function runAll({ groups, getNode, samples, copies, }) {
    const value = [];
    for (const group of groups) {
        const results = await run_group_1.default({
            group,
            getElement: () => to_safe_element_1.default({ getNode, copies }),
            samples,
        });
        value.push(results);
    }
    return value;
}
exports.runAll = runAll;
async function runOneTimed({ task, getNode, copies, samples, }) {
    const result = await run_timed_task_1.getResultForTimedTask({
        task,
        getElement: () => to_safe_element_1.default({ getNode, copies }),
        samples,
    });
    return result;
}
exports.runOneTimed = runOneTimed;
async function runOneStatic({ task, getNode, copies, }) {
    return run_static_task_1.getResultForStaticTask({
        task,
        getElement: () => to_safe_element_1.default({ getNode, copies }),
    });
}
exports.runOneStatic = runOneStatic;
