"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const addon_constants_1 = require("./../addon-constants");
const startMark = `${addon_constants_1.packageName}-start`;
const endMark = `${addon_constants_1.packageName}-end`;
async function mark(taskName, fn) {
    performance.mark(startMark);
    try {
        const result = await fn();
        performance.mark(endMark);
        performance.measure(`🚀 (Task: ${taskName})`, startMark, endMark);
        return result;
    }
    catch (e) {
        performance.mark(endMark);
        performance.measure(`🚀❌ (Task: ${taskName})`, startMark, endMark);
        throw e;
    }
}
exports.default = mark;
