"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_dom_1 = __importDefault(require("react-dom"));
const mark_1 = __importDefault(require("./mark"));
const with_container_1 = __importDefault(require("./with-container"));
const with_duration_1 = __importDefault(require("./with-duration"));
async function runInteractionTask({ task, getElement }) {
    return with_container_1.default(async (container) => {
        react_dom_1.default.render(getElement(), container);
        const duration = await mark_1.default(task.name, () => with_duration_1.default((controls) => task.run({ controls, container })));
        react_dom_1.default.unmountComponentAtNode(container);
        return duration;
    });
}
exports.default = runInteractionTask;
