"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getResultForStaticTask = void 0;
const get_error_result_1 = __importDefault(require("./get-error-result"));
const print_error_1 = __importDefault(require("./print-error"));
const mark_1 = __importDefault(require("./mark"));
const with_container_1 = __importDefault(require("./with-container"));
async function runStaticTask({ task, getElement }) {
    return await with_container_1.default(async (container) => {
        return await mark_1.default(task.name, () => task.run({ getElement, container }));
    });
}
async function getResultForStaticTask({ task, getElement, }) {
    try {
        const value = await runStaticTask({ task, getElement });
        const result = {
            type: 'static',
            taskName: task.name,
            value,
        };
        return result;
    }
    catch (error) {
        print_error_1.default({ task, error });
        return get_error_result_1.default({ task, error });
    }
}
exports.getResultForStaticTask = getResultForStaticTask;
