"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_dom_1 = __importDefault(require("react-dom"));
const addon_constants_1 = require("./../addon-constants");
async function withContainer(fn) {
    const container = document.createElement('div');
    container.setAttribute(`data-${addon_constants_1.packageName}-managed-container`, 'true');
    container.style.visibility = 'invisible';
    document.body.appendChild(container);
    const result = await fn(container);
    react_dom_1.default.unmountComponentAtNode(container);
    if (document.body.contains(container)) {
        document.body.removeChild(container);
    }
    return result;
}
exports.default = withContainer;
